      subroutine avercen(ngal,nl,r,x,y,xaver,yaver,ierr)
      
c     this subroutine averages the centra
c     of the last 3 ellipses with r < rcen & tries to substitute
c     these values into the ellipses with r > rcen.
c     
      
      
      include 'param.inc'
      include 'declare.inc'
      
      integer 	nl(ngal)
      real            xaver(ngal),yaver(ngal)
      character*128	string
      
      call startsub('AVERCEN')
      
      do 10 igal=1,ngal
         do 11 il=1,nl(igal)-1
            if (r(1,il,igal).le.rcen.and.r(1,il+1,igal).gt.rcen) then
               ilmax=il
               goto 12
            end if
 11      continue
         if (debug.ge.2) then
            write(string,
     $           '('' AVERCEN: no ellipses with r > rcen '')')
            call gwrits(string,1)
            write(string,'('' AVERCEN: rcen, r1, r2 = '',3f10.2)')
     &           rcen,r(1,1,igal),r(1,nl(igal),igal)
            call gwrits(string,1)
         end if
         ilmax=nl(igal)
         
 12      continue
         
         isum=0
         xsum=0.
         ysum=0.
         naver=3
         do 20 iaver=1,naver
            il=ilmax+1-iaver
            if (il.gt.1) then
               xsum=xsum+x(1,il,igal)
               ysum=ysum+y(1,il,igal)
               isum=isum+1
            end if
 20      continue
         
         if (isum.ne.0) then
            xaver(igal)=xsum/float(isum)
            yaver(igal)=ysum/float(isum)
         else
            write(string,'(
     $           '' AVERCEN: ERROR: no ellipses with r < rcen '')')
            call gwrits(string,2)
            ierr=1
            return
         end if
         
         if (ilmax.lt.nl(igal)) then
            if (debug.ge.2) then
               write(string,'(
     $              '' AVERCEN: substitute r1, r2 = '',3f10.2)')
     &              r(1,ilmax+1,igal),r(1,nl(igal),igal)
               call gwrits(string,1)
            end if
            do 30 il=ilmax+1,nl(igal)
               x(1,il,igal)=xaver(igal)
               y(1,il,igal)=yaver(igal)
 30         continue
         end if
         
 10   continue
      
      ierr=0
      return
      end
      
      
      subroutine avershape(ngal,nl,r,e,t,eaver,taver,ierr)
      
c     this subroutine averages the ellipticity & position angle
c     of the last 3 ellipses with r < rshap & tries to substitute
c     these values into the ellipses with r > rshap.
c     
      
      include 'param.inc'
      include 'declare.inc'
      
      integer 	nl(ngal)
      real            eaver(ngal),taver(ngal)
      character*128	string
      
      call startsub('AVERSHAPE')
      
      do 10 igal=1,ngal
         
         do 11 il=1,nl(igal)-1
            if (r(1,il,igal).le.rshap.
     $           and.r(1,il+1,igal).gt.rshap) then
               ilmax=il
               goto 12
            end if
 11      continue
         
         if (debug.ge.2) then
            write(string,
     $           '('' AVERSHAP: no ellipses with r > rshap '')')
            call gwrits(string,1)
            write(string,'('' AVERSHAP: rshap, r1, r2 = '',3f10.2)')
     &           rshap,r(1,1,igal),r(1,nl(igal),igal)
            call gwrits(string,1)
         end if
         ilmax=nl(igal)
         
 12      continue
         
         xfsum=0.
         yfsum=0.
         ifsum=0
         naver=3
         do 20 iaver=1,naver
            il=ilmax+1-iaver
            xfsum=xfsum+e(1,il,igal)*sin(2.*t(1,il,igal))
            yfsum=yfsum+e(1,il,igal)*cos(2.*t(1,il,igal))
            ifsum=ifsum+1
 20      continue
         
         if (ifsum.gt.0) then
            eaver(igal)=sqrt(xfsum*xfsum+yfsum*yfsum)/float(ifsum)
            taver(igal)=0.5*atan2(xfsum,yfsum)
         else
            write(string,
     $           '('' AVERSHAPE: ERROR: no ellipses with r < rshap '')')
            call gwrits(string,2)
            ierr=1
            return
         end if

         if (taver(igal).ge.pi) taver(igal)=taver(igal)-pi
         if (taver(igal).lt.0.) taver(igal)=taver(igal)+pi
         
         if (ilmax.lt.nl(igal)) then
            if (debug.ge.2) then
               write(string,'(
     $              '' AVERSHAP: substitute r1, r2 = '',3f10.2)')
     &              r(1,ilmax+1,igal),r(1,nl(igal),igal)
               call gwrits(string,1)
            end if
            do 30 il=ilmax+1,nl(igal)
               e(1,il,igal)=eaver(igal)
               t(1,il,igal)=taver(igal)
 30         continue
         end if
         
 10   continue
      
      ierr=0
      return
      end
