      subroutine clip (n, f, clipfrac)
      
C     subroutine clips deviant points
c     if cliphigh=cliplow=0 then:
C       the largest 2 and smallest 2 values are elimainated if
C       there are more than 20 good points; otherwise the smallest
C       and the largest are eliminated
c     if 0 < cliphigh/low < 1:
c       use cliphigh/low to throw out deviant points

      include 'param.inc'
      
      real f(n)
      real g(MAXSAMP)
      character*80 string
      
      real max1,max2,min1,min2
      
      call startsub('CLIP')

      if (cliphigh.eq.0. .and. cliplow.eq.0.) then
      
      max1=-1.e30
      max2=-1.e30
      min1=1.e30
      min2=1.e30
      imax1=0
      imax2=0
      imin1=0
      imin2=0
      
      
      ngood=0
      do 10 i=1,n
         fi=f(i)
         if (fi.gt.VALMIN) then
            if (fi.gt.max1) then
               if (imax1.ne.0) then
                  max2=f(imax1)
                  imax2=imax1
               end if
               max1=fi
               imax1=i
            else if (fi.gt.max2) then
               max2=fi
               imax2=i
            end if
            if (fi.lt.min1) then
               if (imin1.ne.0) then
                  min2=f(imin1)
                  imin2=imin1
               end if
               min1=fi
               imin1=i
            else if (fi.lt.min2) then
               min2=fi
               imin2=i
            end if
            ngood=ngood+1
         end if
 10   continue
      
      if (ngood.ge.20) then
         f(imin1)=VALBAD
         f(imin2)=VALBAD
         f(imax1)=VALBAD
         f(imax2)=VALBAD
         clipfrac=1.-float(ngood-4)/n
      else if (ngood.ge.10) then
         f(imin1)=VALBAD
         f(imax1)=VALBAD
         clipfrac=1.-float(ngood-2)/n
      end if
      
      else
         if (n.gt.MAXSAMP) then
            string='CLIP: ERROR - array too long '
            call gwrits(1,string)
            return
         end if
         ngood=0
         do i=1,n
            if (f(i).ge.VALMIN) then
               ngood=ngood+1
               g(ngood)=f(i)
            end if
         end do
         if (ngood.gt.1) then
            call sort1d(ngood,g)
            n1=max(1,min(int(ngood*cliplow+1),ngood))
            min1=g(n1)
            n1=max(1,min(int(ngood*(1.-cliphigh)),ngood))
            max1=g(n1)
            if (min1.gt.max1) then
               n1=max(1,min(int(ngood/2.),ngood))
               min1=g(n1)
               max1=min1
            end if
            clipfrac=0
            do i=1,n
               if (f(i).lt.min1.or.f(i).gt.max1) then 
                  f(i)=VALBAD
                  clipfrac=clipfrac+1
               end if
            end do
            clipfrac=clipfrac/float(n)
         else
            clipfrac=1.
         end if
      end if
         
      return
      end
