      subroutine devisub
      
      include 'param.inc'
      include 'array.inc'

      
      character 	image*128,header*60,string*128
      character*128     outputlist,outputfile,residual
      real      	buf1(2048)
      real		bufdif(2048),bufdata(2048)
      real              noise
      logical		high(MAXNPIX),low(MAXNPIX),within
c     
c     
      
      call gproms('image',' ',' ',image,ierr)
      if (ierr.ne.0) return
      call gproms('residual','.res',' ',residual,ierr)
      if (ierr.ne.0) return
      call gproms('outputfile','.resth',' ',outputfile,ierr)
      if (ierr.ne.0) return
      call gproms('outputlist','.pos.del',' ',outputlist,ierr)
      if (ierr.ne.0) return
      call gpromr('readnoise',0.,' ',readnoise,ierr)
      if (ierr.ne.0) return
      call gpromr('epadu',1.,' ',epadu,ierr)
      if (ierr.ne.0) return
      call gpromr('threshold',3.,' ',threshold,ierr)
      if (ierr.ne.0) return
      call gpromr('grow',2.,' ',grow,ierr)
      if (ierr.ne.0) return
      call gpromi('ngrow',3,' ',ngrow,ierr)
      if (ierr.ne.0) return
      
      
      call gimopen(10,image,ierr)
      if (ierr.ne.0) then
         string=' DEVIATE: cannot open input file '//image
         call gwrits(string,1)
         return
      end if
      
      call gimhead(10,header,ncol,nrow,ierr)
      if (ierr.ne.0) return
      
      call imname(image,residual)
      call gimopen(12,residual,ierr)
      if (ierr.ne.0) then
         string=' DEVIATE: cannot open input file '//residual
         call gwrits(string,1)
         return
      end if
      
      call gimhead(12,header,ncol,nrow,ierr)
      if (ierr.ne.0) return
      
      
      rnoiseadu=(readnoise/epadu)**2
      
      ipix=1
      do 10 irow=1,nrow
         call gimrow(12,irow,ncol,bufdif,ierr)
         if (ierr.ne.0) return
         call gimrow(10,irow,ncol,bufdata,ierr)
         if (ierr.ne.0) return
         
         do 11 i=1,ncol
            if (bufdata(i).ge.VALMIN) then
               fit=bufdata(i)-bufdif(i)
               noise=((fit+rnoiseadu)/epadu)
               if (noise.lt.1) noise=1.
               pix(ipix)=bufdif(i)*bufdif(i)/noise
               if (bufdif(i).lt.0.) pix(ipix)=-pix(ipix)
            else
               pix(ipix)=0.
            end if
            high(ipix)=.false.
            low(ipix)=.false.
            ipix=ipix+1
 11      continue
 10   continue
      
      val=threshold**2
      valext=grow**2
      if (valext.le.0.) ngrow=0
      
      call clean(ncol,nrow,pix,high,val,.true.)
      do 20 i=1,ngrow
         call clean(ncol,nrow,pix,high,valext,.false.)
 20   continue
      
      do 21 i=1,nrow*ncol
         if (pix(i).gt.-1e20) pix(i)=-pix(i)
 21   continue
      
      call clean(ncol,nrow,pix,low,val,.true.)
      do 22 i=1,ngrow
         call clean(ncol,nrow,pix,low,valext,.false.)
 22   continue
      
      ipix=1
      do 30 irow=1,nrow
         call gimrow(12,irow,ncol,buf1,ierr)
         if (ierr.ne.0) return
         do 31 i=1,ncol
            pix(ipix)=0.
            if (high(ipix).or.low(ipix)) pix(ipix)=buf1(i)
            ipix=ipix+1
 31      continue
 30   continue
      
      call imname(image,outputfile)
      if (outputfile.ne.' ') then
         call  gimwrit(outputfile,ncol,nrow,pix,header,ierr)
         if (ierr.ne.0) return
      end if
      
      call imname(image,outputlist)
      if (outputlist.ne.' ') then
         open(unit=1,file=outputlist,status='unknown',err=999)
         ipix=0
         do 40 irow=1,nrow
            i0=0
            do 41 icol=1,ncol
               ipix=ipix+1
               within=(pix(ipix).ne.0.)
               if (within.and.i0.eq.0) i0=icol
               if (.not.within.and.i0.ne.0) then
                  write(1,'(1x,4i4)') i0,icol-1,irow,irow
                  i0=0
               end if
 41         continue
            if (i0.ne.0) write(1,'(1x,4i4)',err=999) i0,ncol,irow,irow
 40      continue
         close(unit=1,iostat=ierr)
      end if
      
      call gimclose(10,ierr)
      call gimclose(12,ierr)
      return
 999  string='DEVIATE: ERROR open or writing to file '
      call gwrits(string,2)
      call gimclose(10,ierr)
      call gimclose(12,ierr)
      close(unit=1,iostat=ierr)
      return
      end

      subroutine clean(ncol,nrow,data,high,val,fill)

      real		data(ncol,nrow)
      logical		fill,high(ncol,nrow)

      do 10 j=1,nrow
         do 11 i=1,ncol
            if (data(i,j).gt.val) then
               if (fill) then
                  high(i,j)=.true.
               else
		  do 12 ii=-1,1
                     do 13 jj=-1,1
			i0=i+ii
			j0=j+jj
			if (i0.ge.1.and.i0.le.ncol
     $                       .and.j0.ge.1.and.j0.le.nrow) then
                        if (high(i0,j0)) high(i,j)=.true.
                     end if
 13               continue
 12            continue
            end if
         end if
 11   continue
 10   continue

      return
      end
