%module galphot

%include typemaps.i

%{
#include "cbind.h"
#include "arrayobject.h"
%}

%typemap(python,arginit) const float *ARRAY (long na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) const float *ARRAY {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, 'f', 0, 0);
/*   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, o->descr->type, 0, 0);*/
   array= (PyArrayObject *) PyArray_Cast( a, 'f');
   $target = (float *) ( array->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) const float *ARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}

/*--------------------------*/

%typemap(python,in) const float *ARRAY2 {
   PyArrayObject *array;
   array = (PyArrayObject *) $source;
   $target = (float *) ( array->data);
}


/*--------------------------*/


/*--------------------------*/

%typemap(python,ignore) int *IOUTPUT (int ftemp) {
   ftemp = 0;
   $target = &ftemp;
}

%typemap(python,argout) int *IOUTPUT {
    PyObject *o;
    o = PyInt_FromLong( (long) *$source);
    $target = t_output_helper($target, o);
}

/*--------------------------*/

%typemap(python,ignore) float *TEMPARRAY  (PyArrayObject *TEMPArray) {
    import_array();
}

%typemap(python,check) float *TEMPARRAY {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = ((PyArrayObject *) _obj0)->dimensions[0];
    naxes[1] = ((PyArrayObject *) _obj0)->dimensions[1];
    TEMPArray= (PyObject *) PyArray_FromDims(naxis,naxes, 'f');
    $target = ($type ) ( (PyArrayObject *) TEMPArray)-> data;
    free((int *) naxes);
    na[0] += 1;
    na[na[0]] = (long ) TEMPArray;
}

%typemap(python,argout) float *TEMPARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}


/*--------------------------*/


/*--------------------------*/

%typemap(python,ignore) float *RESARRAY  (PyArrayObject *RESArray) {
    import_array();
}

%typemap(python,check) float *RESARRAY {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = ((PyArrayObject *) _obj0)->dimensions[0];
    naxes[1] = ((PyArrayObject *) _obj0)->dimensions[1];
    RESArray= (PyObject *) PyArray_FromDims(naxis,naxes, 'f');
    $target = ($type ) ( (PyArrayObject *) RESArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *RESARRAY {
    $target = t_output_helper($target, (PyObject *) RESArray);
}

/*--------------------------*/


%typemap(python,ignore) float *INTEN  (PyArrayObject *IntenArray) {
    import_array();
}

%typemap(python,check) float *INTEN {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    IntenArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) IntenArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *INTEN {
    $target = t_output_helper($target, (PyObject *) IntenArray);
}

/*--------------------------*/


%typemap(python,ignore) float *S  (PyArrayObject *SArray) {
    import_array();
}

%typemap(python,check) float *S {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    SArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) SArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *S {
    $target = t_output_helper($target, (PyObject *) SArray);
}

/*--------------------------*/


%typemap(python,ignore) float *X  (PyArrayObject *XArray) {
    import_array();
}

%typemap(python,check) float *X {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    XArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) XArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *X {
    $target = t_output_helper($target, (PyObject *) XArray);
}

/*--------------------------*/


%typemap(python,ignore) float *Y  (PyArrayObject *YArray) {
    import_array();
}

%typemap(python,check) float *Y {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    YArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) YArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *Y {
    $target = t_output_helper($target, (PyObject *) YArray);
}

/*--------------------------*/


%typemap(python,ignore) float *R  (PyArrayObject *RArray) {
    import_array();
}

%typemap(python,check) float *R {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    RArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) RArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *R {
    $target = t_output_helper($target, (PyObject *) RArray);
}

/*--------------------------*/


%typemap(python,ignore) float *E  (PyArrayObject *EArray) {
    import_array();
}

%typemap(python,check) float *E {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    EArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) EArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *E {
    $target = t_output_helper($target, (PyObject *) EArray);
}

/*--------------------------*/


%typemap(python,ignore) float *T  (PyArrayObject *TArray) {
    import_array();
}

%typemap(python,check) float *T {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    TArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) TArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *T {
    $target = t_output_helper($target, (PyObject *) TArray);
}

/*--------------------------*/


%typemap(python,ignore) float *CIRC  (PyArrayObject *CIRCArray) {
    import_array();
}

%typemap(python,check) float *CIRC {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    CIRCArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) CIRCArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *CIRC {
    $target = t_output_helper($target, (PyObject *) CIRCArray);
}

/*--------------------------*/


%typemap(python,ignore) float *ELLIP  (PyArrayObject *ELLIPArray) {
    import_array();
}

%typemap(python,check) float *ELLIP {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 2;
    ArrayType=PyArray_FLOAT;
    ELLIPArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) ELLIPArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *ELLIP {
    $target = t_output_helper($target, (PyObject *) ELLIPArray);
}

/*--------------------------*/

%typemap(python,ignore) float *FLAG  (PyArrayObject *FlagArray) {
    import_array();
}

%typemap(python,check) float *FLAG {
    int *naxes;
    int i,ns;
    int naxis = 2;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 4;
    ArrayType=PyArray_FLOAT;
    FlagArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) FlagArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *FLAG {
    $target = t_output_helper($target, (PyObject *) FlagArray);
}

/*--------------------------*/

%typemap(python,ignore) float *H  (PyArrayObject *HArray) {
    import_array();
}

%typemap(python,check) float *H {
    int *naxes;
    int i,ns;
    int naxis = 4;
    int ArrayType;
    naxes = (int *) malloc((naxis+1)*sizeof(long));
    naxes[0] = 128;
    naxes[1] = 9;
    naxes[2] = 2;
    naxes[3] = 2;
    ArrayType=PyArray_FLOAT;
    HArray= (PyObject *) PyArray_FromDims(naxis,naxes, ArrayType);
    $target = ($type ) ( (PyArrayObject *) HArray)-> data;
    free((int *) naxes);
}

%typemap(python,argout) float *H {
    $target = t_output_helper($target, (PyObject *) HArray);
}

/*--------------------------*/


%typemap(python,ignore) int nx (int ftemp) {
   ftemp = 0;
}

%typemap(python,check) int nx {
    $target = ((PyArrayObject *) _obj0)->dimensions[1];
}

%typemap(python,ignore) int ny (int gtemp) {
   gtemp = 0;
}

%typemap(python,check) int ny {
    $target = ((PyArrayObject *) _obj0)->dimensions[0];
}

/*--------------------------*/

typedef int Logical;

void cphotfit(const float *ARRAY, float *RESARRAY, float *TEMPARRAY, int nx, int ny,
 float xcen, float ycen, Logical ellipsefit, int *IOUTPUT,
 float rmin0, float rmax0, float radfac0, float linear0, float rshap0, float rcen0,
 float errshap0, float errcen0, int iter10, int iter20, int hmax0,
 float dposmax0, float dellmax0, float dangmax0, float r10, float r20,
 int nsammax0, float fracmin0, float cliplow0, float cliphigh0, int debug0,
 float extend0, int outfill0, int npolres0, Logical tabellipfit, Logical justres,
 const float *ARRAY2, const float *ARRAY2, const float *ARRAY2, const float *ARRAY2,
 const float *ARRAY2, const float *ARRAY2, const float *ARRAY2, const float *ARRAY2,
 const float *ARRAY2, const float *ARRAY2, const float *ARRAY2);


