      subroutine interpd2(nx,ny,data,x,y,value)

c     fourth order interpolation

      real*4	data(nx,ny),x,y,value
      integer	nx,ny
      
      include 'param.inc'
      
      integer	ix(0:3),iy(0:3)
      real	cx(0:3),cy(0:3),fy(0:3)
      
      if (x.gt.nx.or.x.lt.0.or.y.gt.ny.or.y.lt.0) then
         value=VALBAD
         return
      end if
      
      ix(1)=int(x)
      iy(1)=int(y)
      ix(2)=ix(1)+1
      iy(2)=iy(1)+1
      ix(3)=ix(1)+2
      iy(3)=iy(1)+2
      ix(0)=ix(1)-1
      iy(0)=iy(1)-1
      
      dx=x-float(ix(1))
      dy=y-float(iy(1))
      
      if (ix(0).le.0)  ix(0)=ix(0)+nx
      if (ix(1).le.0)  ix(1)=ix(1)+nx
      if (ix(2).gt.nx) ix(2)=ix(2)-nx
      if (ix(3).gt.nx) ix(3)=ix(3)-nx
      if (iy(0).le.0)  iy(0)=iy(0)+ny
      if (iy(1).le.0)  iy(1)=iy(1)+ny
      if (iy(2).gt.ny) iy(2)=iy(2)-ny
      if (iy(3).gt.ny) iy(3)=iy(3)-ny	
      
      do 10 i=0,3
         do 11 j=0,3
            if (data(ix(i),iy(j)).lt.VALMIN ) then
               value=VALBAD
               return
            end if
 11      continue
 10   continue
      
      cx(0)=-dx*(dx-1.0)*(dx-2.0)*.1666666
      cx(1)=(dx*dx-1.0)*(dx-2.0)*.5
      cx(2)=-dx*(dx+1.0)*(dx-2.0)*.5
      cx(3)=dx*(dx*dx-1.0)*0.1666666
      cy(0)=-dy*(dy-1.0)*(dy-2.0)*.1666666
      cy(1)=(dy*dy-1.0)*(dy-2.0)*.5
      cy(2)=-dy*(dy+1.0)*(dy-2.0)*.5
      cy(3)=dy*(dy*dy-1.0)*0.1666666
      
      
      do 20 i=0,3
         fy(i)=0.
         do 21 j=0,3
            fy(i)=fy(i)+cx(j)*data(ix(j),iy(i))
 21      continue
 20   continue
      value=cy(0)*fy(0)+cy(1)*fy(1)+cy(2)*fy(2)+cy(3)*fy(3)
      
      return
      end
