      subroutine iteration(nx,ny,pix,ngal,nl,flag,inten,s,x,y,r,e,t,h,
     &     dif,ellipfit,residual,intupdate,ierr)


c     this subroutines does 1 iteration on the data
c     if residual=true then the program calculates the residual from
c     the previous model first
c     if ellipfit=true the program tries to fit ellipses; hence calculates
c     only harmonicals up to 2nd order.
c     if intupdate=true the program updates the intensity values

      include 'param.inc'
      include 'declare.inc'

      integer nx,ny,nl(ngal)

      real    pix(nx,ny)
      real	dif(nx,ny)
      logical	ellipfit,residual,intupdate

      real	xs(5,MAXSAMP),ys(5,MAXSAMP),ls(MAXSAMP),vs(MAXSAMP)
      real	sts(MAXSAMP),cts(MAXSAMP)
      real	har(2,2,MAXHARM,MAXLINE)
      integer	nhar(MAXLINE)

      integer	il,ns


      call startsub('ITERATION')

      igal=1

      if (residual) then
c           calculate residuals - but do not include harmonicals
         nh=0
         call model(nx,ny,pix,ngal,nl(igal),inten,s,x,y,r,e,t,h,
     &        nh,residual,dif,ellipfit,ierr)
         if (ierr.ne.0) return
      end if
      
      do 100 il=1,nl(igal)
c     loop over the annuli
         call setsample(nl(igal),x,y,r,e,t,il,il,igal,xs,ys,ls,ns,ierr)
         if (ierr.ne.0) return
         
         if (residual) then
            call getsample(nx, ny, dif, ns,xs,ys,vs,badfrac,ierr)
            if (ierr.ne.0) return
         else
            call getsample(nx, ny, pix, ns,xs,ys,vs,badfrac,ierr)
            if (ierr.ne.0) return
         end if
         
         if (ellipfit) then
            if (badfrac.lt.(1.-fracmin)) then
               nhar(il)=2
            else
               nhar(il)=-1
            end if
         else
            if (badfrac.lt.(1.-fracmin)) then
               nhar(il)=flag(1,il,igal)
            else if (badfrac.lt.1) then
               nhar(il)=0
            else
               nhar(il)=-1
            end if
         end if
         
         flag(1,il,igal)=nhar(il)
         flag(2,il,igal)=badfrac
         
         call getsincos(ns,xs,ys,ls,sts,cts,x,y,r,e,t,igal,ierr)
         if (ierr.ne.0) return
         
         call clip( ns, vs, clipfrac)
         flag(3,il,igal)=clipfrac
         
         call harmonics(ns,cts,sts,vs,nhar(il),
     &        har(1,1,1,il),res,nres,ierr)
         if (ierr.ne.0) return

 100  continue

      call newradii(igal,nl(igal),nhar,har,flag,inten,s,x,y,r,e,t,h,
     $     ierr)
      if (ierr.ne.0) return

      if (intupdate) then
         call  newintens(nl(igal),inten,nhar,har,igal,residual,ierr)
         if (ierr.ne.0) return
      end if

      call getslope(nl(igal),r,inten,nhar,s,igal,ierr)
      if (ierr.ne.0) return

      if (ellipfit) then
         call ellipupdate(nl(igal),nhar,har,s,x,y,r,e,t,igal,ierr)
         if (ierr.ne.0) return
         call harmupdate(nl(igal),nhar,har,s,r,h,igal,ierr)
         if (ierr.ne.0) return
      else
         call harmupdate(nl(igal),nhar,har,s,r,h,igal,ierr)
         if (ierr.ne.0) return
      end if


      ierr=0
      return
      end
