      subroutine modmags(nx,ny,ngal,nl,inten,s,x,y,r,e,t,h,nhmax,
     &     lemag,lcmag,dif,skyval,ssky,ron,cfactor,zero,
     &     exptime,rscale,paflag,ccdflag,dalpha,ierr)
      
c     subroutine calculates the magnitudes inside ellipses and
c     circles
      
      
      include 'param.inc'
      include 'declare.inc'
      include 'moddeclare.inc'
      
      real	dif(nx,ny)
      integer   nl(ngal),nhmax 

      logical lemag, lcmag, paflag, ccdflag
      real    skyval, ssky, ron, cfactor, zero, exptime, rscale
      real    dalpha 
      
      real	hc(MAXHARM,MAXLINE),hs(MAXHARM,MAXLINE)
      real	st(MAXHARM),ct(MAXHARM)
      real	cxx(MAXLINE),cxy(MAXLINE),cyy(MAXLINE)
      
      logical out,circle
      character*128	string
      
      call startsub('MODMAGS')
      
      do 1  igal=1,ngal
         
         im=1
         
 4       if (im.eq.1) then
           do 5 il=1,nl(igal)
             eextra(1,il,igal) = e(1,il,igal)
             eextra(2,il,igal) = e(2,il,igal)
             textra(1,il,igal) = t(1,il,igal)
             textra(2,il,igal) = t(2,il,igal)
             xextra(1,il,igal) = x(1,il,igal)
             xextra(2,il,igal) = x(2,il,igal)
             yextra(1,il,igal) = y(1,il,igal)
             yextra(2,il,igal) = y(2,il,igal)
c             nhmax = 0
 5         continue  

         else 

           xcen = 0.
           ycen = 0.
           ncen = 10
           if (nl(igal).lt.ncen) ncen=nl(igal) 

           do 8 il=1,ncen
             xcen = xcen+x(1,il,igal)
             ycen = ycen+y(1,il,igal)
 8         continue
           xcen = xcen/float(ncen)
           ycen = ycen/float(ncen) 

           do 9 il=1,nl(igal)
             eextra(1,il,igal) = 0.
             eextra(2,il,igal) = 0.
             textra(1,il,igal) = 0.
             textra(2,il,igal) = 0.
             xextra(1,il,igal) = xcen
             xextra(2,il,igal) = 0.
             yextra(1,il,igal) = ycen
             yextra(2,il,igal) = 0.
c             nhmax = 0
 9         continue 
            
           if (debug.ge.2) then
              write(string,'('' MODEL: xcen ycen'',2f8.2)') xcen, ycen
              call gwrits(string,1)
           end if

         end if

         if (debug.ge.2) then
            write(string,'('' MODEL: initialize nhmax='',i5)') nhmax
            call gwrits(string,1)
         end if
         call modelinit(igal,nl(igal),inten,s,r,eextra,textra,h,
     &        cxx,cxy,cyy,nhmax,hc,hs,circle,ierr)
         if (ierr.ne.0) return
         
         do 10 il=1,nl(igal)
           sumint(il) = 0.
           area(im,il,igal) = 0
 10      continue

         if (debug.ge.2) then
            write(string,'('' MODEL: initialize ok'')') 
            call gwrits(string,1)
         end if
           
         do 20 iy=1,ny
            do 21 ix=1,nx
               xi=float(ix)
               yi=float(iy)
               
               if (iv0.lt.1) iv0=1
               if (iv0.ge.nl(igal)) iv0=nl(igal)-1
               iv1=iv0+1
      
               call findellipse(xi,yi,iv0,iv1,nl(igal),igal,xextra,
     &               yextra,cxx,cxy,cyy,d0,d1,out,ierr)
               if (ierr.ne.0) return

               if (debug.ge.10) then
                write(string,'('' MODELVALUE: '',
     &               l10,2f8.2,2i8,2f8.2)') 
     $          out,xi,yi,iv0,iv1,d0,d1
                call gwrits(string,1)
               end if
               
               do 22 il=nl(igal),iv1,-1
                 sumint(il) = sumint(il)+(dif(ix,iy)-skyval)
                 area(im,il,igal) = area(im,il,igal)+1 
 22            continue
 21         continue
 20      continue

c CALCULATE MAGNITUDES AND ERRORS
      
      do 30 il=nl(igal),1,-1
        if (area(im,il,igal).le.0) area(im,il,igal)=1
        totint(1,im,il,igal) = sumint(il)

        if (skyval.lt.0.) skyval=0.
        if (cfactor.lt.0.) cfactor=1.
        if (ssky.lt.0.) ssky=1. 

        totint(2,im,il,igal) =
     &  sqrt(area(im,il,igal)*(ron**2+skyval/cfactor)+
     &  totint(1,im,il,igal)/cfactor+(area(im,il,igal)*ssky)**2) 

        if (exptime.le.0.) exptime=1. 
        if (totint(1,im,il,igal).gt.0.) then
          magni(1,im,il,igal) = zero -
     &      2.5*log10(totint(1,im,il,igal)/exptime)
          magni(2,im,il,igal) = 1.086*totint(2,im,il,igal)/
     &                          totint(1,im,il,igal) 
        else if (il.lt.nl(igal)) then
          magni(1,im,il,igal) = magni(1,im,il+1,igal)
          magni(2,im,il,igal) = magni(2,im,il+1,igal) 
        else
          magni(1,im,il,igal) = 30.0
          magni(2,im,il,igal) = 0.
        end if

C SURFACE BRIGHTNESS ONLY FOR ELLIPSES
        
        if (im.eq.1) then
          if (rscale.le.0.) rscale=1. 
          meanmu(1,il,igal) = magni(1,1,il,igal)+
     &      2.5*log10(area(1,il,igal)*rscale*rscale) 
          meanmu(2,il,igal) = magni(2,1,il,igal) 
          
          if((inten(1,il,igal)-skyval).gt.0.) then
            mu(1,il,igal) = zero - 
     &        2.5*log10((inten(1,il,igal)-skyval)/
     &        (exptime*rscale*rscale)) 
            mu(2,il,igal) = 1.086*
     &       sqrt(inten(2,il,igal)*inten(2,il,igal)+ssky*ssky)/
     &       (inten(1,il,igal)-skyval)
          else
            mu(1,il,igal) = 30.0
            mu(2,il,igal) = 0.
          endif

        end if
      
C SCALING OF R, Correction of P.A. to N-E 
        
        if (im.eq.2) then
          r(1,il,igal) = r(1,il,igal)*rscale
          r(2,il,igal) = r(2,il,igal)*rscale

        if (paflag) then
           t(1,il,igal) = t(1,il,igal)-pi/2.
           if (t(1,il,igal).lt.0.) t(1,il,igal)=t(1,il,igal)+pi
           t(1,il,igal) = pi-t(1,il,igal)
         if (ccdflag) then
           t(1,il,igal) = t(1,il,igal)+(dalpha*180./pi)
           if (t(1,il,igal).lt.0.) t(1,il,igal)=t(1,il,igal)+pi
           if (t(1,il,igal).gt.pi) t(1,il,igal)=t(1,il,igal)-pi 
         end if
        end if  
        end if

      if (debug.ge.4) then
           write(string,'('' MODMAGS: t,mag,area,r '',
     &     f8.2,f8.2,i15,f8.2)') t(1,il,igal),
     &     magni(1,im,il,igal), area(im,il,igal),
     &     r(1,il,igal)
           call gwrits(string,1)
      end if

 30   continue  
      
      if (im.eq.1.and.lcmag) then
        im = im+1
        goto 4
      end if

 1    continue

      ierr=0
      return
      end
