      subroutine photfit(rawpix,dif,pix,nx,ny,
     &    xcen0,ycen0,ellipsefit,ierr,
     &    rmin0,rmax0,radfac0,linear0,rshap0,rcen0,
     &    errshap0,errcen0,iter10,iter20,hmax0,
     &    dposmax0,dellmax0,dangmax0,r10,r20,
     &    nsammax0,fracmin0,cliplow0,cliphigh0,debug0,
     &    extend0,outfill0,npolres0,tabellipfit, justres,
     &       flag,inten,s,x,y,r,e,t,h,circ,ellip)

c     this subroutine is THE MAIN ELLIPSEFITTING / HARMONICAL FITTING
c     routine

      logical ellipsefit,prompt
      
      include 'param.inc'
      include 'declare.inc'
c      include 'array.inc'
      
      character*128 image,output,galaxy,deletion,intable,outtable
      character*128 string
      integer  ngal
      
      
      real  xcen(MAXGAL), ycen(MAXGAL)
      real      xaver(MAXGAL),yaver(MAXGAL),eaver(MAXGAL),taver(MAXGAL)
      real      rawpix(NX*NY),dif(NX*NY)
      real      pix(NX*NY)
c      real      dif(NX*NY)
c      real      pix(MAXNPIX),dif(MAXNPIX)
      integer nl(MAXGAL)
      logical ellipfit,residual,intupdate,ldif,tabellipfit,justres
      
      character*60 object

      ngal = 1
      xcen(1) = xcen0
      ycen(1) = ycen0

      rmin = rmin0
      rmax = rmax0
      radfac = radfac0
      linear = linear0
      rshap = rshap0
      rcen = rcen0
      errshap = errshap0
      errcen = errcen0
      iter1 = iter10
      iter2 = iter20
      hmax = hmax0
      dposmax = dposmax0
      dellmax = dellmax0
      dangmax = dangmax0
      r1 = r10
      r2 = r20
      nsammax = nsammax0
      fracmin = fracmin0
      cliplow = cliplow0
      cliphigh = cliphigh0
      debug = debug0
      extend = extend0
      outfill = outfill0
      npolres = npolres0

      do i=1,nx
        do j=1,ny
          pix((j-1)*nx+i) = rawpix((j-1)*nx+i)
          dif((j-1)*nx+i) = 0.0
        end do
      end do

      call startsub('PHOTFIT')
      
C     GET INPUT PARAMETERS
      
c      if (prompt) then
c         call inppro(image,output,galaxy,deletion,intable,outtable,
c     &        ngal,ellipsefit,ierr)
c         if (ierr.ne.0) return
c      else
C     call inpnam(image,output,galaxy,deletion,intable,outtable,
c     &        ngal,ellipsefit,ierr)
c         if (ierr.ne.0) return
c      end if
      
C     OPEN AND READ INPUT IMAGE
      
c      call gimopen (1,image, ierr)
c      if (ierr.ne.0) then
c         string=' PHOTFIT: Error opening '// image
c         call gwrits(string,2)
c         return
c      end if
c      
c      call gimhead (1,object,nx,ny,ierr)
c      if (ierr.ne.0) then
c         call gimclose(1,ierr)
c         return
c      end if
      
C     CHECK OTHER INPUT VALUES
      
c      call checkinput(image,output,intable,outtable,nx,ny,ierr)
c      if (ierr.ne.0) return
      
c      call readin (1, nx, ny, pix ,ierr)
c      if (ierr.ne.0) then
c         call gimclose(1,ierr)
c         return
c      end if
c      
c      call gimclose(1,ierr)
c      if (ierr.ne.0) return
      
C     MASK FLAGGED PIXELS
      
c      call maskpix(nx,ny,pix,image,deletion)
      
C     IF INPUT TABLE GIVEN WITH STARTUP VALUES, READ IT.
      
c      if (intable.eq.' ') then
c         call getcen(ngal,xcen,ycen,image,galaxy, ierr)
c         if (ierr.ne.0) return

      if (.not.tabellipfit) then

        nl(1) = 0
        do jr=1,MAXLINE
          if (r(1,jr,1).gt.0) nl(1) = nl(1) + 1
        end do

        if (nl(1).eq.0) then
          call setupfit(nx,ny,ngal,nl,xcen,ycen,flag,x,y,r,e,t,h,ierr)
          if (ierr.ne.0) return
        end if

        else

        nl(1) = 0
        do jr=1,MAXLINE
          if (r(1,jr,1).gt.0) nl(1) = nl(1) + 1
        end do
        xcen(1) = x(1,1,1)
        ycen(1) = y(1,1,1)

c      else
c         call imname(image,intable)
c         call readtable(intable,
c     $        tabellipfit,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
c         if (ierr.ne.0) return
         if (justres) goto 3
         if (ellipsefit) then 
cc     SKIP THE HARMONICS FITTING
            if (tabellipfit) then
cc     TABLE IS OUTPUT FROM ELLIPSE FITTING 
               goto 2
            else
cc     TABLE IS OUTPUT FROM HARMONICALS FITTING
               goto 1
            end if
         else
cc     REDO THE HARMONICAL FITTING
         end if
      end if
      
C     FIRST HARMONICS FITTING
      
      ellipfit=.false.
      residual=.false.
      intupdate=.true.
c      if (debug.ge.1) then
c         write(string,'('' PHOTFIT: Fitting harmonicals'')')
c         call gwrits(string,1)
c      end if
      
      call iteration(nx,ny,pix,ngal,nl,flag,inten,s,x,y,r,e,t,h,
     &     dif,ellipfit,residual,intupdate,ierr)
      if (ierr.ne.0) return
      
 1    if (ellipsefit) then
         
C     NOW ELLIPSE FITTING
C     FIRST CALCULATE MAXIMUM RADIUS OF FITTING
         
         call cutoff(ngal,nl,r,h,ierr)
         if (ierr.ne.0) return
         
C     INITIALIZE THE CENTRA & SHAPES OF THE ELLIPSES
         
         call initelpa(ngal,nl,r,h,e,t)
         
 2       outfill=.false.
         residual=.false.
         intupdate=.true.
         ellipfit=.true.
         
         do 10 i=1,iter1+iter2
            if (debug.ge.1) then
               write(string,'('' PHOTFIT: Fitting Ellipses'')')
               call gwrits(string,1)
            end if
            residual=i.gt.iter1
            
C     DO THE ELLIPSE FITTING. IF RESIDUAL=TRUE, THE MODEL VALUES ARE
C     CALCULATED AND SUBTRACTED BEFORE THE FIT
            
            call iteration(nx,ny,pix,ngal,nl,flag,inten,s,x,y,r,e,t,
     &           h,dif,ellipfit,residual,intupdate,ierr)
            if (ierr.ne.0) return
            
C     AVERAGE THE CENTRA OF THE OUTER POINTS IF NECESSARY
            
            call avercen(ngal,nl,r,x,y,xaver,yaver,ierr)
            if (ierr.ne.0) return
 10      continue
         
         if (extend) then
            
C     EXTEND RADIAL INTERVAL, CALCULATE INTENSITY.
            
            call nharm(ngal,nl,flag,0)
            ellipfit=.false.
            residual=.false.
            call avershape(ngal,nl,r,e,t,eaver,taver,ierr)
            if (ierr.ne.0) return
            call rextend(ngal,nl,flag,r,x,y,e,t,h,
     $           xaver,yaver,eaver,taver)
            if (debug.gt.0) call gwrits
     $           (' PHOTFIT: fit to extended radial interval',1)
            call iteration(nx,ny,pix,ngal,nl,flag,inten,s,x,y,r,e,t,
     &           h,dif,ellipfit,residual,intupdate,ierr)
            if (ierr.ne.0) return
            if (iter2.gt.0) then
               residual=.true.
               iter3=min(3,iter2)
               do 30 i=1,iter3
                  if (debug.gt.0) 
     $                 call gwrits
     $                 (' PHOTFIT: fit to extended radial interval',1)
                  call iteration(nx,ny,pix,ngal,nl,flag,inten,s,x,y,
     $                 r,e,t,h,dif,ellipfit,residual,intupdate,ierr)
 30            continue
               if (ierr.ne.0) return
            end if
         end if
         
C     CALCULATE HIGHER ORDER RESIDUALS
         
         call nharm(ngal,nl,flag,hmax)
         ellipfit=.false.
         intupdate=.false.
         if (debug.gt.0) 
     $        call gwrits
     $        (' PHOTFIT: calculating higher order residuals',1)
         call iteration(nx,ny,pix,ngal,nl,flag,inten,s,x,y,r,e,t,
     &        h,dif,ellipfit,residual,intupdate,ierr)
      end if
      
c      call imname(image,outtable)
      
C     WRITE RESULTS TO TABLE
      
c      call  writetable(outtable,image,galaxy,deletion,intable,
c     $     ellipsefit,ngal,nl,flag,inten,s,x,y,r,e,t,h,ierr)
c      if (ierr.ne.0) return
      
c      call imname(image,output)
c      if (output.ne.' ') then
c         
cC     EVALUATE RESIDUALS FROM THE FIT AND WRITE TO OUTPUT IMAGE
c         

 3       continue
         ldif=.true.
         outfill=.true.
         if (ellipsefit) hmax=0.
         if (debug.ge.1) then
            write(string,'('' PHOTFIT: Evaluating residual frame'')')
            call gwrits(string,1)
         end if

       call model(nx,ny,pix,ngal,nl,inten,s,x,y,r,e,t,h,hmax,ldif,dif,
     &        ellipsefit,ierr)
         if (ierr.ne.0) return

      do i=1,nx
        do j=1,ny
          pix((j-1)*nx+i) = dif((j-1)*nx+i)
        end do
      end do

      do i=1,nx
        do j=1,ny
          dif((j-1)*nx+i) = pix((j-1)*nx+i)
        end do
      end do


c         
c         call gimwrit(output, nx, ny, dif, object,ierr)
c         if (ierr.ne.0) return
c      end if
      
      return
      end
