      subroutine setsample(nl,x,y,r,e,t,il1,il2,igal,xs,ys,ls,ns,ierr)
      
c     this subroutine calculates the values of x,y at which to get
c     the pixel values or the areas defined by 4 points whithin which
c     to get the pixel values
      
      include 'param.inc'
      include 'declare.inc'
      
      real	xs(5,MAXSAMP),ys(5,MAXSAMP),ls(MAXSAMP)
      character*128	string	
      
      call startsub('SETSAMPLE')
      
      is=0
      do 10 il=il1,il2
         is0=is
         rad=r(1,il,igal)
         rad2=r(2,il,igal)
         if (il.eq.1) then
            rad1=rad*rad/rad2
         else
            rad1=r(2,il-1,igal)
         end if
         
         t0 =t(1,il,igal)
         e0 =e(1,il,igal)
         x0 =x(1,il,igal)
         y0 =y(1,il,igal)
         
         ns=2.0*pi*rad
         if (ns.lt.hmax*8) ns=hmax*8
         if (ns.lt.20)    ns=20
         if (ns.gt.nsammax)   ns=nsammax
         
         if (rad.lt.r1) then
            call setellipse(x0,y0,e0,t0,rad,0.,ns,is,xs,ys,ierr)
            if (ierr.ne.0) return
         else if (rad.gt.r1.and.rad.lt.r2) then
            irad=(rad2-rad1)+0.5
            if (irad.lt.1) irad=1
            do 11 ir=1,irad
               ri=rad1+(rad2-rad1)*(float(ir)-0.5)/float(irad)
               call setellipse(x0,y0,e0,t0,ri,0.,ns,is,xs,ys,ierr)
               if (ierr.ne.0) return
 11         continue
         else
            call setellipse(x0,y0,e0,t0,rad1,rad2,ns,is,xs,ys,ierr)
            if (ierr.ne.0) return
         end if
         
         do 12 i=is0+1,is
            ls(i)=il
 12      continue
         
         
 10   continue
      ns=is
      
      if (debug.ge.6) then
         write(string,'('' SETSAMPLE: r1,r2,x,y,e,t='',10f8.2)')
     &        rad1,rad2,x0,y0,e0,t0
         call gwrits(string,1)
      end if
      if (debug.ge.10) then
         write(string,'('' SETSAMPLE: values of x,y '')')
         call gwrits(string,1)
         do 20 j=1,ns
	    write(string,'(8f10.2)') (xs(i,j),ys(i,j),i=1,4)
	    call gwrits(string,1)
 20      continue
      end if
      
      ierr=0
      return
      end
      
      subroutine setellipse(x0,y0,e0,t0,rad1,rad2,ns,is,xs,ys,ierr)
      
      include 'param.inc'
      include 'declare.inc'

c     this subroutine does the actual work. If rad2 != 0 then an area
c     will be defined; otherwise a point.
      
      real	xs(5,MAXSAMP),ys(5,MAXSAMP),ls(MAXSAMP)
      character*128 string
      
      if (e0.gt.1) then
         write(string,'('' SETELLIPSE: ERROR: ellip > 1 '')')
         call gwrits(string,2)
         ierr=1
         return
      end if
      a=rad1/sqrt(1.-e0)
      b=a*(1.-e0)
      acost=a*cos(t0)
      bcost=b*cos(t0)
      asint=a*sin(t0)
      bsint=b*sin(t0)
      
      if (rad2.ne.0) radfac=rad2/rad1
      
      is0=is
      do 10 i=1,ns
         is=is+1
         if (rad2.eq.0) then
            phi=2.*pi*float(i)/float(ns)
            cp=cos(phi)
            sp=sin(phi)
            xs(1,is)=x0+acost*cp-bsint*sp
            ys(1,is)=y0+asint*cp+bcost*sp
            do 11 ir=2,5
               xs(ir,is)=0.
               ys(ir,is)=0.
 11         continue
         else
            phi=2.*pi*(float(i)-0.5)/float(ns)
            cp=cos(phi)
            sp=sin(phi)
            xd=acost*cp-bsint*sp
            yd=asint*cp+bcost*sp
            xs(1,is)=x0+xd
            ys(1,is)=y0+yd
            xs(2,is)=x0+xd*radfac
            ys(2,is)=y0+yd*radfac
            if (i.eq.1) then
               isb=is0+ns
            else
               isb=is-1
            end if
            xs(3,isb)=xs(2,is)
            ys(3,isb)=ys(2,is)
            xs(4,isb)=xs(1,is)
            ys(4,isb)=ys(1,is)
            xs(5,is)=1.
            ys(5,is)=1.
         end if
 10   continue
      
      ierr=0
      return
      end

