      subroutine harmupdate(nl,nhar,har,s,r,h,igal,ierr)
      
c     puts new values into array 'h'
      
      include 'param.inc'
      include 'declare.inc'
      
      real	har(2,2,MAXHARM,MAXLINE)
      integer	nhar(MAXLINE)
      
      character*128	string
      
      call startsub('HARMUPDATE')
      
      do 10 il=1,nl
         if (nhar(il).ge.0) then
            harfac=abs(r(1,il,igal)*s(1,il,igal))
            if (harfac.ne.0.) then
               harfac=1./harfac
            else
               harfac=1.e20
            end if
            do 11 ih=1,nhar(il)
               do 12 ir=1,2
                  do 13 is=1,2
                     h(ir,is,ih,il,igal)=har(ir,is,ih+1,il)*harfac
 13               continue
 12            continue
 11         continue
            do 14 ih=nhar(il)+1,MAXHARM
               do 15 ir=1,2
                  do 16 is=1,2
                     h(ir,is,ih,il,igal)=0.
 16               continue
 15            continue
 14         continue
         else
            write(string,'('' HARMUPDATE: ERROR: nhar < 0 '')')
            call gwrits(string,2)
            ierr=1
            return
         end if
 10   continue
      
      
      if (debug.ge.4) then
         do 20 il=1,nl
            write(string,'('' HARMUPDATE: '')')
            call gwrits(string,1)
            do 21 ih=1,nhar(il)
               write(string,'(2(g12.4,'' +- '',g12.4,4x))')
     $              ((h(ie,is,ih,il,igal),ie=1,2),is=1,2)
               call gwrits(string,1)
 21         continue
 20      continue
      end if
      
      
      return
      end
      
      
      subroutine ellipupdate(nl,nhar,har,s,x,y,r,e,t,igal,ierr)
      
c     puts new values into e,t arrays

      include 'param.inc'
      include 'declare.inc'
      
      real	har(2,2,MAXHARM,MAXLINE)
      integer	nhar(MAXLINE)
      
      character*128	string
      
      do 10 il=1,nl
         
         if (nhar(il).ge.0) then
            harfac=abs(r(1,il,igal)*s(1,il,igal))
            if (harfac.ne.0.) then
               harfac=1./harfac
            else
               harfac=1.e20
            end if
            if (dposmax.ne.0..and.nhar(il).ge.1) then
               pfac=abs(s(1,il,igal))
               if (pfac.ne.0.) then
                  pfac=1./pfac
               else
                  pfac=1.e20
               end if
               
               dpmaj=har(1,1,2,il)*pfac
               dpmin=har(1,2,2,il)*pfac*(1.-e(1,il,igal))
               
               if (abs(dpmaj).gt.dposmax) dpmaj=sign(dposmax,dpmaj)
               if (abs(dpmin).gt.dposmax) dpmin=sign(dposmax,dpmin)
               

               ct=cos(t(1,il,igal))
               st=sin(t(1,il,igal))
               x(1,il,igal)=x(1,il,igal)+dpmaj*ct-dpmin*st
               y(1,il,igal)=y(1,il,igal)+dpmaj*st+dpmin*ct
               x(2,il,igal)=0.5*sqrt(har(2,1,2,il)**2+har(2,2,2,il)**2)*
     &              pfac
               y(2,il,igal)=x(2,il,igal)
            end if
            
            if (nhar(il).ge.2) then
               if (dangmax.ne.0.) then
                  ediv=e(1,il,igal)
                  if (ediv.le.0) ediv=0.1
                  tfac=2.*(1.-e(1,il,igal))*harfac/
     $                 (ediv*(2.-e(1,il,igal)))
                  dt=har(1,2,3,il)*tfac
                  if (abs(dt).gt.dangmax) dt=sign(dangmax,dt)
                  t(1,il,igal)=t(1,il,igal)+dt
                  t(2,il,igal)=abs(tfac*har(2,2,3,il))
               end if
               
               if (dellmax.ne.0.) then
                  efac=2.*(1.-e(1,il,igal))*harfac
                  de=har(1,1,3,il)*efac
                  if (abs(de).gt.dellmax) de=sign(dellmax,de)
                  e(1,il,igal)=e(1,il,igal)+de
                  e(2,il,igal)=abs(efac*har(2,1,3,il))
               end if
               
               ellmax=0.9
               if (e(1,il,igal).lt.0.0) then
                  e(1,il,igal)=-e(1,il,igal)
                  if (e(1,il,igal).gt.0.1) e(1,il,igal)=0.1
                  t(1,il,igal)=t(1,il,igal)+pi/2.
               else if (e(1,il,igal).gt.ellmax) then
                  e(1,il,igal)=ellmax
               end if
               
               if (t(1,il,igal).gt.pi) then
                  t(1,il,igal)=t(1,il,igal)-pi
               else if (t(1,il,igal).lt.0.) then
                  t(1,il,igal)=t(1,il,igal)+pi
               end if

               if (debug.ge.3) then
                  write(string,'('' ELLIPUPDATE :'',10f8.3)')
     &                 e(1,il,igal),de,t(1,il,igal),dt,dpmin,dpmaj
                  call gwrits(string,1)
               end if
               

            end if
            
         end if
 10   continue
      
      return
      end
